--------------------------------------------------
-- CS2D Standard Bot AI                         --
-- V1: 01.08.2010 - www.UnrealSoftware.de       --
-- Last Update: 26.04.2017                      --
--                                              --
-- Used prefixes in this script                 --
-- ai_ = AI function (AI API, invoked by CS2D)  --
-- vai_ = AI variable                           --
-- fai_ = AI helper function                    --
--                                              --
--------------------------------------------------

-- Includes
dofile("bots/includes/settings.lua")	-- track settings
dofile("bots/includes/general.lua")		-- general helper functions
dofile("bots/includes/buy.lua")			-- buying
dofile("bots/includes/decide.lua")		-- decision making process
dofile("bots/includes/engage.lua")		-- engage/attack/battle (find target and attack)
dofile("bots/includes/fight.lua")		-- fight (attack if target is set)
dofile("bots/includes/follow.lua")		-- follow another player
dofile("bots/includes/collect.lua")		-- collect good nearby items
dofile("bots/includes/radio.lua")		-- radio message handling
dofile("bots/includes/bomb.lua")		-- bomb planting and defusing
dofile("bots/includes/hostages.lua")	-- rescue hostages

--msg("bomber id : "..dildo.bomberId)
-- Setting Cache
vai_set_gm=0							-- Game Mode Setting (equals "sv_gamemode", Cache)
vai_set_botskill=0						-- Bot Skill Setting (equals "bot_skill", Cache)
vai_set_botweapons=0					-- Bot Weapons Setting (equals "bot_weapons", Cache)
vai_set_debug=0							-- Debug Setting (equals "debugai", Cache)
fai_update_settings()

-- Per Player Variables
vai_mode={}; vai_smode={}				-- current mode (state) and sub-mode (sub-state / parameter)
vai_timer={}							-- timer
vai_destx={}; vai_desty={}				-- destination x|y
vai_aimx={}; vai_aimy={}				-- aim at x|y
vai_px={}; vai_py={}					-- previous x|y
vai_target={}							-- target
vai_reaim={}; vai_rescan={}				-- re-aim / re-scan (line of fire checks)
vai_itemscan={}							-- item scan countdown (for collecting items)
vai_buyingdone={}						-- buying done?
vai_radioanswer={}						-- radio answer?
vai_radioanswert={}
------------------------------------------------------
vai_etat={}
vai_rotation={}
vai_missionThrow={}	
vai_startThrowPos={}
vai_throwNumPos={}						-- rotation
for i=1,32 do
	vai_missionThrow[i]=true
	vai_etat[i]=1
	vai_rotation[i]=0
	vai_throwNumPos[i]=nil
	vai_startThrowPos[i]=true	
	vai_mode[i]=-1; vai_smode[i]=0
	vai_timer[i]=0
	vai_destx[i]=0; vai_desty[i]=0
	vai_aimx[i]=0; vai_aimy[i]=0
	vai_px[i]=0; vai_px[i]=0
	vai_target[i]=0 
	vai_reaim[i]=0; vai_rescan[i]=0
	vai_itemscan[i]=0
	vai_buyingdone[i]=0
	vai_radioanswer[i]=0; vai_radioanswert[i]=0
end

-- "ai_onspawn" - AI On Spawn Function
-- This function is called by CS2D automatically after each spawn of a bot
-- Parameter: id = player ID of the bot
function ai_onspawn(id)
	--ai_selectweapon(id,69)
end

--addhook('move','Mymove')
--function Mymove(id)
	--msg(player(id,"tilex")..' '..player(id,"tiley"))
	--msg(player(id,"process"))
--end 
tabThrowNade = {
{{21,7},{20,7},228},
{{24,7},{24,6},48},
{{24,12},{23,12},227},
{{21,1},{22,1},123},
{{18,6},{17,6},-45},
--{{14,6},{15,6},56},
{{12,6},{11,6},-48},
{{8,7},{8,8},123},
{{5,6},{4,6},235},
{{2,10},{3,10},60},
{{15,16},{16,16},124},
{{21,17},{21,18},231},
{{10,15},{10,14},-58},
{{16,10},{17,10},120},
{{22,12},{21,12},-72},

---zone de camp 
{{26,11},{26,12},120},
{{26,16},{26,15},120},
{{7,13},{6,13},-46},
{{1,14},{1,15},226},
{{1,17},{1,18},226},
{{1,5},{1,4},-40}
}

function action(id,etat,throw)
	if vai_etat[id] == 1 then
		normalAIAction(id)
		
		--msg(dildo.bomberId)
		if dildo.bomberId ~= id then
			--rand = math.random(0,360)
			boolRand= math.random(0,2) 
			vai_rotation[id]=(vai_rotation[id]+18)%360
			ai_rotate(id,vai_rotation[id])
			if boolRand < 1 and player(id,"process") < 1 then
				local itemlist = playerweapons(id)
				randItem = math.random(1,#itemlist)
				ai_selectweapon(id,itemlist[randItem])
			end
		end 
	else 
		if dildo.bomberId == id then
			if vai_missionThrow[id] then 
			--	randThrow = math.random(1,4)
				randThrow = throw
				vai_missionThrow[id] = false
			end
			throwNadePos(id,tabThrowNade[randThrow])
		else
			vai_etat[id] = 1
		end 
	end 
end
function throwNadePos(id,tabThrowNade)
	if vai_startThrowPos[id] then 
		ai_goto(id,tabThrowNade[1][1],tabThrowNade[1][2])
		if(player(id,"tilex") == tabThrowNade[1][1] and player(id,"tiley") == tabThrowNade[1][2])then
			vai_startThrowPos[id] = false
		end 
	else 
		ai_goto(id,tabThrowNade[2][1],tabThrowNade[2][2])
		if(player(id,"tilex") == tabThrowNade[2][1] and player(id,"tiley") == tabThrowNade[2][2])then
			ai_rotate(id,tabThrowNade[3])
			ai_selectweapon(id,dildo.bomberTypeBomb)
			ai_attack(id)
			parse('equip '..id..' '..dildo.bomberTypeBomb)
			vai_missionThrow[id] = true
			vai_startThrowPos[id] = true
			vai_etat[id] = 1
		end
	end 
end

function arroundNadesTiles(id)
	for i, pos in pairs(tabThrowNade) do
		if (player(id,"tilex") - pos[1][1]) > -1 and (player(id,"tilex") - pos[1][1]) < 1 and (player(id,"tiley") - pos[1][2]) > -1 and (player(id,"tiley") - pos[1][2]) < 1 then
			return i
		end 
	end
	return nil
	
end 
-- "ai_update_living" - AI Update Living Function
-- This function is called by CS2D automatically for each *LIVING* bot each frame
-- Parameter: id = player ID of the bot
function ai_update_living(id)

	--[[if dildo.bomberId == id then
		msg(vai_mode[id])
	end --]]
	randomEtatNade = math.random(1,10)
	vai_throwNumPos[id] = arroundNadesTiles(id)

	if arroundNadesTiles(id) ~= nil and randomEtatNade < 2 then
		--msg(vai_throwNumPos[id])
		vai_etat[id] = 2
		action(id,vai_etat[id],vai_throwNumPos[id])
	else  
		action(id,vai_etat[id],0)
	end
	--
	--msg(itemlist[1])
	-- Engage / Aim
	-- scan surroundings for close enemies and attack them if possible
	
		
end
function normalAIAction(id)
	if dildo.bomberId ~= id then
		fai_engage(id)
	end
	-- bot might get kicked or killed for teamkills etc - check if it is still in-game
	if not player(id,"exists") then
		return
	elseif player(id,"team")<=0 or player(id,"health")<=0 then
		return
	end
	---msg(player(id,"weapontype"))
	if player(id,"weapontype") ~= 69 and player(id,"weapontype") ~= 55 and  player(id,"weapontype") ~= 51 and player(id,"weapontype") ~= 52 and player(id,"weapontype") ~= 53 then 
		if dildo.bomberId ~= id then
			ai_selectweapon(id,69)
		else 
			ai_selectweapon(id,dildo.bomberTypeBomb)
		end 
	end 
	-- Send radio answer when radio answer timer expires
	if vai_radioanswert[id]>0 then
		-- decrease timer
		vai_radioanswert[id]=vai_radioanswert[id]-1
		if vai_radioanswert[id]<=0 then
			-- send answer and reset timer
			ai_radio(id,vai_radioanswer[id])
			vai_radioanswer[id]=0; vai_radioanswert[id]=0
		end
	end
		
	-- Collect nearby items
	if dildo.bomberId ~= id then
		fai_collect(id)
	end
	
	-- Set AI Debug Output (only visible if CS2D setting "debugai" is set to 1)
	if vai_set_debug then
		ai_debug(id,"m:"..vai_mode[id]..", sm:"..vai_smode[id].." ta:"..vai_target[id].." ti:"..vai_timer[id])
	end
	
	-- The AI is basically a state machine
	-- vai_mode contains the current state, vai_smode contains a sub mode or parameter for the state
	
	if vai_mode[id]==0 then
		-- ############################################################ 0: IDLE -> decide what to do next
		vai_timer[id]=0; vai_smode[id]=0
		
		fai_decide(id)
		
		
	elseif vai_mode[id]==1 then
		-- ############################################################ 1: CAMP -> do nothing (wait)
		fai_wait(id,0)
		
	elseif vai_mode[id]==2 then
		-- ############################################################ 2: GOTO -> go to destination
		local result=ai_goto(id,vai_destx[id],vai_desty[id])

		if result==1 then
			vai_mode[id]=0
		elseif result==0 then
			vai_mode[id]=0
		else
			fai_walkaim(id)
		end
		
	elseif vai_mode[id]==3 then
		-- ############################################################ 3: ROAM -> randomly run around
		if ai_move(id,vai_smode[id])==0 then
			-- Bot failed to walk (way blocked) -> turn
			if (id%2)==0 then
				vai_smode[id]=vai_smode[id]+45
			else
				vai_smode[id]=vai_smode[id]-45
			end
			if dildo.bomberId ~= id then 
				vai_timer[id]=math.random(150,250)
			end
		end
		if dildo.bomberId ~= id then
			fai_walkaim(id)
			fai_wait(id,0)
		end 

	elseif vai_mode[id]==4 then
		-- ############################################################ 4: FIGHT -> fight
		fai_fight(id)

	elseif vai_mode[id]==5 then
		-- ############################################################ 5: HUNT -> hunt another player
		if player(vai_smode[id],"exists") then
			if player(vai_smode[id],"health")>0 then
				if ai_goto(id,player(vai_smode[id],"tilex"),player(vai_smode[id],"tiley"))~=2 then
					vai_mode[id]=0
				end
				return
			end
		end
		-- End Hunt
		vai_mode[id]=0
		
	elseif vai_mode[id]==6 then
		-- ############################################################ 6: COLLECT -> collect item
		if ai_goto(id,vai_destx[id],vai_desty[id])~=2 then
			vai_mode[id]=0
			vai_itemscan[id]=140
		else
			fai_walkaim(id)
		end
		
	elseif vai_mode[id]==7 then
		-- ############################################################ 7: FOLLOW -> follow another player
		fai_follow(id)
		
	elseif vai_mode[id]==8 then
		-- ############################################################ 8: FLASHED -> run around randomly because flashed
		if ai_goto(id,vai_destx[id],vai_desty[id])~=2 then
			fai_randomadjacent(id)
		end
		-- End Flash
		if player(id,"ai_flash")==0 then
			vai_mode[id]=0
		end
	
	elseif vai_mode[id]==50 then
		-- ############################################################ 50: RESCUE -> rescue hostages
		fai_rescuehostages(id)

	elseif vai_mode[id]==51 then
		-- ############################################################ 51: PLANT -> plant bomb
		fai_plantbomb(id)
		
	elseif vai_mode[id]==52 then
		-- ############################################################ 52: DEFUSE -> defuse bomb
		fai_defuse(id)
	
	elseif vai_mode[id]==-1 then
		-- ############################################################ -1: BUY -> buy equipment
		fai_buy(id)
	
	else
		-- ############################################################ INVALID MODE -> select new mode
		-- This state should never be reached under normal circumstances
		if vai_set_debug then
			print("invalid AI mode: "..vai_mode[id])
		end
		vai_mode[id]=0
	end
end 

-- "ai_update_dead" - AI Update Dead Function
-- This function is called by CS2D automatically for each *DEAD* bot each second
-- Parameter: id = player ID of the bot
function ai_update_dead(id)
	-- Try to respawn (if not in normal gamemode)
	fai_update_settings()
	if vai_set_gm~=0 then
		ai_respawn(id)
	end
end

-- "ai_hear_radio" - AI Hear Radio
-- This function is called once for each radio message
-- Parameter: source = player ID of the player who sent the radio message
-- Parameter: radio = radio message ID
function ai_hear_radio(source,radio)
	fai_radio(source,radio)
end

-- "ai_hear_chat" - AI Hear Chat
-- This function is called once for each chat message
-- Parameter: source = player ID of the player who sent the radio message
-- Parameter: msg = chat text message
-- Parameter: teamonly = team only chat message (1) or public chat message (0)
function ai_hear_chat(source,msg,teamonly)
	-- This bot implementation simply ignores all chat messages
end